---
title: Firefox 72 for Developers
slug: Mozilla/Firefox/Releases/72
tags:
  - '72'
  - Firefox
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}</p>

<p class="summary">This article provides information about the changes in Firefox 72 that will affect developers. Firefox 72 was released on January 7, 2020.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<p><a href="/en-US/docs/Tools/Web_Console">Console</a>:</p>

<ul>
 <li>In the <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter#Multi-line_mode">multi-line mode of the interactive JS interpreter</a>, you can open and save files using the keyboard shortcuts <kbd>Ctrl</kbd> + <kbd>O</kbd> and <kbd>Ctrl</kbd> + <kbd>S</kbd>, respectively ({{bug(1592308)}}).</li>
 <li>You can set a <a href="/en-US/docs/Tools/Web_Console/Console_messages#Async_stack_frames">preference so that asynchronous messages are visually separated</a> ({{bug(1592969)}}).</li>
</ul>

<p><a href="/en-US/docs/Tools/Debugger">JavaScript debugger</a>:</p>

<ul>
 <li>You can now right/<kbd>Ctrl</kbd> click on objects in the Scopes panel, and choose <em>Property set</em> or <em>Property get</em> to <a href="/en-US/docs/Tools/Debugger/How_to/Use_watchpoints#Set_a_watchpoint">set watchpoints</a> ({{bug(1574192)}}).</li>
</ul>

<p><a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a>:</p>

<ul>
 <li>The Timings tab now shows <a href="/en-US/docs/Tools/Network_Monitor/request_details#Queued_Started_Downloaded">queued, started, and downloaded</a> times for each resource ({{bug(1580431)}}).</li>
</ul>

<p><a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a>:</p>

<ul>
 <li>You can set a <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS#View_media_rules_for_color-scheme-preference">preference to enable a simulator</a> for different values of the <code><a href="/en-US/docs/Web/CSS/@media/prefers-color-scheme">prefers-color-scheme</a></code> media feature ({{bug(1550804)}}).</li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>The <a href="/en-US/docs/Tools/Scratchpad">Scratchpad</a> feature has been removed ({{bug(1519103)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<p><em>No changes.</em></p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>CSS Shadow Parts are now enabled. This includes the <a href="/en-US/docs/Web/HTML/Global_attributes/part"><code>part</code> attribute</a> and <a href="/en-US/docs/Web/CSS/::part"><code>::part</code> pseudo-element</a>, which allow shadow hosts to selectively expose chosen elements from their shadow tree to the outside page for styling purposes ({{bug(1559074)}}).</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Motion_Path">CSS Motion Path</a> has been shipped ({{bug(1582554)}}, also see the <a href="https://groups.google.com/forum/#!topic/mozilla.dev.platform/nOOIRsuxvuc">Intent to Ship</a>). This includes:
  <ul>
   <li>{{cssxref("offset")}}</li>
   <li>{{cssxref("offset-path")}}</li>
   <li>{{cssxref("offset-anchor")}}</li>
   <li>{{cssxref("offset-distance")}}</li>
   <li>{{cssxref("offset-rotate")}}</li>
  </ul>
 </li>
 <li>The individual transform properties — {{cssxref("scale")}}, {{cssxref("rotate")}}, and {{cssxref("translate")}} — are now enabled by default ({{bug(1424900)}}). </li>
</ul>

<h4 id="Removals_2">Removals</h4>

<h3 id="SVG">SVG</h3>

<p><em>No changes</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Nullish_coalescing_operator">nullish coalescing operator</a> has been implemented ({{bug(1566141)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>{{domxref("FormDataEvent")}} and <a href="/en-US/docs/Web/API/FormData/Using_FormData_Objects#Using_a_formdata_event">event-based form participation</a> is now enabled by default ({{bug(1594708)}}).</li>
</ul>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The <a href="/en-US/docs/Web/API/Geolocation_API">Geolocation API</a> has had some interface name updates, as per recent spec changes ({{bug(1575144)}}):

  <ul>
   <li>{{domxref("Coordinates")}} has been changed to {{domxref("GeolocationCoordinates")}}.</li>
   <li>{{domxref("Position")}} has been changed to {{domxref("GeolocationPosition")}}.</li>
   <li>{{domxref("PositionError")}} has been changed to {{domxref("GeolocationPositionError")}}.</li>
  </ul>
 </li>
 <li>A number of properties have been updated to use standard stringifiers ({{bug(824857)}}):
  <ul>
   <li>{{domxref("DOMTokenList.value")}}</li>
   <li>{{domxref("HTMLHyperlinkElementUtils.href")}}</li>
   <li>{{domxref("Location.href")}}</li>
   <li>{{domxref("MediaList.mediaText")}}</li>
   <li>{{domxref("URL.href")}}</li>
   <li>{{domxref("WorkerLocation.href")}}</li>
  </ul>
 </li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<ul>
 <li>{{domxref("Notification.requestPermission()")}} and {{domxref("PushManager.subscribe()")}} can now only be called in response to a user gesture such as a <code><a href="/en-US/docs/Web/API/Element/click_event">click</a></code> event ({{bug(1593644)}}).</li>
</ul>

<h4 id="Service_workers">Service workers</h4>

<ul>
 <li>The {{domxref("WindowOrWorkerGlobalScope.crossOriginIsolated")}} property is now supported ({{bug(1591892)}}).</li>
</ul>

<h4 id="Media_Web_Audio_and_WebRTC">Media, Web Audio, and WebRTC</h4>

<ul>
 <li>The {{domxref("MediaDevices.getDisplayMedia()")}} method can now only be called in response to a user gesture such as a <code><a href="/en-US/docs/Web/API/Element/click_event">click</a></code> event ({{bug(1580944)}}).</li>
 <li>The {{domxref("RTCRtpContributingSource")}} dictionary can now include the {{domxref("RTCRtpContributingSource.rtpTimestamp", "rtpTimestamp")}} property, which is a source-generated time at which the packet's media was generated or sampled ({{bug(1583867)}}).</li>
</ul>

<h4 id="Removals_3">Removals</h4>

<ul>
 <li>Removed the non-standard {{DOMxRef("window.mozPaintCount")}} property. ({{bug(1591968)}})</li>
 <li>The {{domxref("BatteryManager")}} interface is no longer exposed to web content ({{bug(1441976)}}).</li>
 <li>{{domxref("Navigator.vibrate()")}} is no longer supported in cross-origin {{htmlelement("iframe")}}s ({{bug(1591113)}}).</li>
 <li>WebRTC no longer supports the <code>rid=</code> and <code>pt=</code> parameters on the <code>simulcast</code> attribute. The new syntax for a line such as "<code>a=simulcast: send rid=7 recv rid=8</code>" is now "<code>a=simulcast: send 7 recv 8</code>". The new syntax has been supported since Firefox 68, so now it's time tor retire support for the old syntax ({{bug(1470568)}}).</li>
</ul>

<h3 id="Security">Security</h3>

<ul>
 <li>Opting-out of MIME sniffing using {{HTTPHeader("X-Content-Type-Options")}} is now also applied to top-level documents if a {{HTTPHeader("Content-type")}} is provided. This can cause HTML web pages to be downloaded instead of being rendered when they are served with a MIME type other than <code>text/html</code>. Make sure to set both headers correctly. ({{bug(1591932)}}).</li>
 <li>Dropped the support for <a href="/en-US/docs/Web/HTTP/Public_Key_Pinning">HTTP Public Key Pinning (HPKP)</a> because of the low adoption rate and interoperability risk. The {{HTTPHeader("Public-Key-Pins")}} and {{HTTPHeader("Public-Key-Pins-Report-Only")}} headers are now silently ignored {{bug(1412438)}}.</li>
</ul>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="WebDriver_conformance_Marionette">WebDriver conformance (Marionette)</h3>

<ul>
 <li>Removed <code>Anon</code> and <code>AnonAttribute</code> strategies from <code>WebDriver:FindElement</code> and <code>WebDriver:FindElements</code> commands ({{bug(1587627)}}).</li>
 <li><code>Webdriver:TakeScreenshot</code> no longer fails if captured area exceeds upper maximum bound for the canvas width, height, or size ({{bug(1590064)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes">API changes</h3>

<ul>
 <li>The <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings/ftpProtocolEnabled">browserSettings.ftpProtocolEnabled</a></code> property has been implemented ({{bug(1592687)}}).</li>
 <li>The <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/types/BrowserSetting/onChange">BrowserSetting.onChange</a></code> event has been implemented ({{bug(1410412)}}).</li>
 <li>The <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/captivePortal/canonicalURL">captivePortal.canonicalURL</a></code> property has been implemented ({{bug(1592932)}}).</li>
 <li>The callback functions for the <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserAction/onClicked">browserAction.onClicked</a></code> and <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/pageAction/onClicked">pageAction.onClicked</a></code> events now include a <code>OnClickData</code> property containing an object whose properties describe the mouse button pressed along with any keyboard modifiers ({{bug(1405031)}}). This allows support for additional types of mouse click.</li>
</ul>

<h3 id="Manifest_changes">Manifest changes</h3>

<p><em>No changes.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Hacks release post: <a href="https://hacks.mozilla.org/2020/01/firefox-72-our-first-song-of-2020/">Firefox 72 — our first song of 2020</a></li>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/72/">Site compatibility for Firefox 72</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(71)}}</p>
